// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "ZipTester.h"

#include "MainFrm.h"

#include ".\Zip\zip.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_SETFOCUS()
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	// create a view to occupy the client area of the frame
	if (!m_wndView.Create(NULL, NULL, AFX_WS_DEFAULT_VIEW,
		CRect(0, 0, 0, 0), this, AFX_IDW_PANE_FIRST, NULL))
	{
		TRACE0("Failed to create view window\n");
		return -1;
	}

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	cs.cx = 800;
	cs.cy = 120;
	cs.lpszClass = AfxRegisterWndClass(0);
	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers
void CMainFrame::OnSetFocus(CWnd* pOldWnd)
{
	// forward focus to the view window
	m_wndView.SetFocus();
}

BOOL CMainFrame::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo)
{
	// let the view have first crack at the command
	if (m_wndView.OnCmdMsg(nID, nCode, pExtra, pHandlerInfo))
		return TRUE;

	// otherwise, do default handling
	return CFrameWnd::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
}


void CMainFrame::OnFileOpen() 
{
	WIN32_FIND_DATA theInfo;
	RecurseDirectory(_T("c:\\"), &theInfo);
//	RecurseDirectory(_T("d:\\"), &theInfo);
	PostMessage(WM_CLOSE);
}

// NOTE:
//		Since this is -or- can be a recursive function, we need to be *VERY*
//		careful about stack space.  Basically, this function only uses 8 bytes
//    of stack space per call into the function (not counting function args).
void CMainFrame::RecurseDirectory(IN LPCTSTR lpszDirectory, IN WIN32_FIND_DATA* pFileInfo)
{
	CString strText;
	
	LPTSTR pszWorkBuf = new TCHAR[_MAX_PATH + 1];
	StrCpy(pszWorkBuf, lpszDirectory);

	// add a backslash and *.* to directory name
	PathAddBackslash(pszWorkBuf);
	StrCat(pszWorkBuf, _T("*.*"));

	HANDLE hFile = ::FindFirstFile(pszWorkBuf, pFileInfo);
	if (hFile != INVALID_HANDLE_VALUE)
	{
		do
		{
			if (pFileInfo->cFileName[0] != TCHAR('.'))
			{
				PathCombine(pszWorkBuf, lpszDirectory, pFileInfo->cFileName);
				if ((pFileInfo->dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY))
					RecurseDirectory(pszWorkBuf, pFileInfo);
				else
				{
					if (!( 
						 (pFileInfo->dwFileAttributes & FILE_ATTRIBUTE_TEMPORARY) ||
						 (pFileInfo->dwFileAttributes & FILE_ATTRIBUTE_SYSTEM) ||
						 (pFileInfo->dwFileAttributes & FILE_ATTRIBUTE_HIDDEN)
						)) 
					{
						LPSTR pszExt = PathFindExtension(pFileInfo->cFileName);
						if (pszExt != NULL && StrCmpI(pszExt+1, "zip") == 0)
						{
//							ZipArchive theArchive;
							PathCombine(pszWorkBuf, lpszDirectory, pFileInfo->cFileName);

							strText.Format(_T("Processing: %-256s"), pszWorkBuf);
							CDC* pDC = GetDC();
							pDC->TextOut(4, 2, strText);
							strText.Format(_T("%-256s"), "");
							pDC->TextOut(20, 20, strText);
							UpdateWindow();

							ZARCHIVE theArchiveSmall;
							ZeroMemory(&theArchiveSmall, sizeof(ZARCHIVE));

							BOOL bResult = zaOpenArchive(&theArchiveSmall, pszWorkBuf);
							if (bResult)
							{
								int nCount = theArchiveSmall.pDirectory->Count;
								for (int i = 0; i < nCount; ++i)
								{
									HGLOBAL hBuffer;
									LPCTSTR pString = (LPCTSTR)zaLoadEntryByIndex(&theArchiveSmall, i, &hBuffer);
									if (pString)
									{
										if (hBuffer)
											::GlobalFree(hBuffer);

										strText.Format(_T("Entry:  %-256s"), pString);
										pDC->TextOut(20, 20, strText);
										UpdateWindow();
									}
									else
										MessageBox(_T("Failed to process zip entry"), _T("Check routines"), MB_OK);
								}
							}
							zaCloseArchive(&theArchiveSmall);

							ReleaseDC(pDC);
						}
					}
				}
			}
		} while (::FindNextFile(hFile, pFileInfo));
	}

	::FindClose(hFile);
	delete[] pszWorkBuf;
}
