// ---------------------------------------------------------------------------
// ZipArchive.h: interface for the ZipArchive class.
// ===========================================================================
#if !defined(AFX_ZIPARCHIVE_H__A7F528A6_1872_4071_BE66_D56CC2DDE0E6__INCLUDED_)
#define AFX_ZIPARCHIVE_H__A7F528A6_1872_4071_BE66_D56CC2DDE0E6__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "Zip.h"
//#include "ZipCentralDir.h"


//////////////////////////////////////////////////////////////////////////
/////////////////////  ZipArchive   /////////////////////////////////////

class ZipArchive  
{
public:
	ZipArchive();
	virtual ~ZipArchive();

	BOOL Open(IN LPCTSTR strFileSpec);
	void Close();

	LONG GetEntryCount() const;
	LPCTSTR LoadEntry(IN ZENTRY* pEntry, IN HGLOBAL& hBuffer);

	eZipError OpenEntry(IN LPCTSTR strEntry, OUT DWORD& dwFileSize);
	void	CloseEntry();
	
	DWORD ReadEntry(IN ZENTRY* pEntry, IN LPVOID pBuf, IN DWORD dwSize);

	// LoadEntry wraps OpenEntry, ReadEntry and CloseEntry into a single call
	// and allocates the memory
	LPCTSTR LoadEntry(IN LONG idx, IN HGLOBAL& hBuffer);
	LPCTSTR LoadEntry(IN LPCTSTR lpszFileSpec, IN HGLOBAL& hBuffer);

	DWORD		GetCrcValue() const;

protected:
// attributes
	BOOL		m_bEntryOpened;
	ULONG		m_uUncomprLeft;
	ULONG		m_uComprLeft;
	DWORD		m_uCrc32;

	ZFIO*				m_pStorage;
	ZDIRECTORY*		m_pDirectory;

//	ZipCentralDir	m_centralDir;

// implementation
	eZipError OpenEntry(IN ZENTRY* pEntry, OUT DWORD& dwFileSize);
};


// ---------------------------------------------------------------------------
// ZipArchive inlines
// ===========================================================================
AFX_INLINE DWORD ZipArchive::GetCrcValue() const
{ return m_uCrc32; }

AFX_INLINE LONG ZipArchive::GetEntryCount() const
{ return m_pDirectory->Count; }


#endif // !defined(AFX_ZIPARCHIVE_H__A7F528A6_1872_4071_BE66_D56CC2DDE0E6__INCLUDED_)
