// ZipCentralDir.h: interface for the CZipCentralDir class.
//
#if !defined(AFX_ZipCentralDir_H__859029E8_8927_4717_9D4B_E26E5DA12BAE__INCLUDED_)
#define AFX_ZipCentralDir_H__859029E8_8927_4717_9D4B_E26E5DA12BAE__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "ZipArchive.h"

int __cdecl compareSearch(const void* elem1, const void* elem2);
int __cdecl compareSort(const void* elem1, const void* elem2);


class ZipCentralDir  
{

public:
	ZipCentralDir();
	virtual ~ZipCentralDir() {}

	int  OpenDirectory(IN LPVOID pArchive);
	void CloseDirectory();

	ZENTRY* GetEntryByIndex(IN LONG idx);
	ZENTRY* FindEntry(IN LPCTSTR strFile);

// gets
	LONG GetEntryCount() const;

	LPCTSTR GetCommentBuffer();
	LPCTSTR GetExtaFieldBuffer();


protected:
// attributes
	static const BYTE m_cbSignature[];
	static const BYTE m_cbExtHeaderSignature[];

	ZENTRY**	m_pArray;
	LONG		m_lArrayCount;
};


AFX_INLINE LONG ZipCentralDir::GetEntryCount() const
{ return m_lArrayCount; }

AFX_INLINE ZENTRY* ZipCentralDir::GetEntryByIndex(IN LONG idx)
{ return (ZENTRY*)m_pArray[idx]; }

AFX_INLINE ZENTRY* ZipCentralDir::FindEntry(IN LPCTSTR lpszFile)
{ return (ZENTRY*)*(DWORD*)::BinarySearch((LPVOID)lpszFile, m_pArray, m_lArrayCount, sizeof(ZENTRY*), compareSearch); }


#endif // !defined(AFX_ZipCentralDir_H__859029E8_8927_4717_9D4B_E26E5DA12BAE__INCLUDED_)
