TITLE	BinarySearch.asm

.586
.model flat, stdcall      ; memory model & calling convention
option casemap :none      ; case sensitive


.code
align 4
; ----------------------------------------------------------------------------
; prototype:
; LPVOID __stdcall BinarySearch(
;		LPVOID pTarget,
;		LPVOID pArray,
;		DWORD dwArrayCount,
;		DWORD dwElemSize
;		int (__cdecl *pfnCOMPARE)(const void* pElem1, const void* pElem2));
; ----------------------------------------------------------------------------
BinarySearch PROC pTarget:dword, pArray:dword, dwArrayCount:dword, dwElemSize:dword, pfnCompare:dword
	; save the information which we need to restore before returning back.
	push	edi
	push	esi

	; set up the registers with our information.
	mov	edi, dwArrayCount		; high end
	sub	esi, esi					; low end
	sub	edi, 1


__BinarySearchLoop:
	; check our bounds
	cmp	esi, edi
	jg		short __BinarySearchNotFound

	; get the mid element index value
	lea	ecx, DWORD PTR [edi+esi]					; mid element
	shr	ecx, 1

	; get the element information
	mov	eax, dwElemSize

	imul	eax, ecx
	push	ecx
	add	eax, pArray

	; call the user-defined compare
	push	eax		; pArray element
	push	pTarget	; pTarget
	call	DWORD PTR pfnCompare	; __cdecl call

	; add back the pushes for the __cdecl call
	add	esp, 4
	
	; test the result and see if they found match
	test	eax, eax

	; get back our 'mid' value and element offset
	pop	eax
	pop	ecx
	
	; branch accordingly
	je		short __BinarySearchEnd
	jl		short __BinaryAdjustUpperHalf

	; move low end bound to search index + 1
	mov	esi, ecx
	add	esi, 1
	jmp	short __BinarySearchLoop


__BinaryAdjustUpperHalf:
	; move high end bound to search index - 1
	mov	edi, ecx
	sub	edi, 1
	jmp	short __BinarySearchLoop


__BinarySearchNotFound:
	sub	eax, eax


__BinarySearchEnd:
	pop	esi
	pop	edi

	ret
BinarySearch ENDP


_TEXT	ends
end
