TITLE	inftrees.asm

.586
.model FLAT

externdef stdcall HeapAlloc			:proto stdcall :dword, :dword, :dword
externdef stdcall HeapFree				:proto stdcall :dword, :dword, :dword
externdef stdcall GetProcessHeap		:proto stdcall

.const
align 8
_lbase DD 003H, 004H, 005H, 006H, 007H, 008H, 009H, 00aH
       DD 00bH, 00dH, 00fH, 011H, 013H, 017H, 01bH, 01fH
       DD 023H, 02bH, 033H, 03bH, 043H, 053H, 063H, 073H
       DD 083H, 0a3H, 0c3H, 0e3H, 0102H,000H, 000H, 000H

_lext	 DD 010H, 010H, 010H, 010H, 010H, 010H, 010H, 010H
       DD 011H, 011H, 011H, 011H, 012H, 012H, 012H, 012H
       DD 013H, 013H, 013H, 013H, 014H, 014H, 014H, 014H
       DD 015H, 015H, 015H, 015H, 010H, 04cH, 042H, 000H
       
_dbase DD 001H, 002H, 003H, 004H, 005H, 007H, 009H, 00dH
       DD 011H, 019H, 021H, 031H, 041H, 061H, 081H, 0c1H
       DD 00101H, 00181H, 00201H, 00301H, 00401H, 00601H, 0801H, 0c01H
       DD 01001H, 01801H, 02001H, 03001H, 04001H, 06001H, 0000H, 000H
       
_dext  DD 010H, 010H, 010H, 010H, 011H, 011H, 012H, 012H
       DD 013H, 013H, 014H, 014H, 015H, 015H, 016H, 016H
       DD 017H, 017H, 018H, 018H, 019H, 019H, 01aH, 01aH
       DD 01bH, 01bH, 01cH, 01cH, 01dH, 01dH, 040H, 040H
	

.data
_TEXT	SEGMENT
_type$ = 8
_lens$ = 12
_codes$ = 16
_table$ = 20
_bits$ = 24
_pTempVar$ = -48
_nMin$ = -28
_nMax$ = -32
_len$ = -16
_root$ = -4
_curr$ = -20
_drop$ = -8
_used$ = -36
_huff$ = -12
_low$ = -56
_mask$ = -64
_end$ = -24
_c$ = 16
_base$ = -44
_extra$ = -40
_nResult$ = -60

.code
align 4
_inflate_table@20 PROC NEAR ; inflate_table

; 62   : {

	push	ebp
	mov	ebp, esp
	sub	esp, 68					; 00000044H
	push	ebx
	push	esi
	push	edi

; 63   : 	TempVars*	pTempVar = (TempVars*)CreateMemory(sizeof(TempVars), HEAP_ZERO_MEMORY);

	invoke GetProcessHeap
	invoke HeapAlloc, eax, 8, 1280

; 64   : 	int nMin;		// minimum code length
; 65   : 	int nMax;		// maximum code length
; 66   : 
; 67   : 	int len;		// a code's length in bits
; 68   : 	int root;	// number of index bits for root table
; 69   : 	int curr;	// number of index bits for current table
; 70   : 	int drop;	// code bits to drop for sub-table
; 71   : 	int left;	// number of prefix codes available
; 72   : 	int used;	// code entries in table used
; 73   : 	unsigned int huff;	// Huffman code
; 74   : 	unsigned int incr;	// for incrementing code, index
; 75   : 	unsigned int fill;	// index for replicating entries
; 76   : 	int low;		// low bits for current root entry
; 77   : 	int mask;	// mask for low root bits
; 78   : 	int end;		// use base and extra for symbol > end
; 79   : 
; 80   : 	int sym;		// index of code symbols
; 81   : 	int v;		// temporary value used in compares/calcs
; 82   : 	
; 83   : 	code c;					// table entry for duplication
; 84   : 	code* next;				// next available space in table
; 85   : 
; 86   : 	const int* base;		// base value table to use
; 87   : 	const int* extra;		// extra bits table to use
; 88   : 	
; 89   : //	ZeroMemory(&tempVar, sizeof(tempVar));
; 90   : 	
; 91   : 	// set up for code type
; 92   : 	if (type == CODES)

	xor	ebx, ebx
	mov	edx, eax
	cmp	DWORD PTR _type$[ebp], ebx
	mov	DWORD PTR _pTempVar$[ebp], edx
	jne	SHORT $L60119

; 93   : 	{
; 94   : 		// dummy values
; 95   : 		base = pTempVar->work;
; 96   : 		extra = pTempVar->work;
; 97   : 		end = 19;
; 98   : 	}
; 99   : 	else if (type == LENS)

	push	1
	mov	DWORD PTR _base$[ebp], edx
	mov	DWORD PTR _extra$[ebp], edx
	mov	DWORD PTR _end$[ebp], 19		; 00000013H
	pop	edi
	jmp	SHORT $L60122
$L60119:
	push	1
	pop	edi
	cmp	DWORD PTR _type$[ebp], edi
	jne	SHORT $L60121

; 100  : 	{
; 101  : 		base = lbase;
; 102  : 		base -= 257;

	mov	eax, OFFSET FLAT:_lbase
	mov	ecx, 1028				; 00000404H
	sub	eax, ecx

; 103  : 		extra = lext;
; 104  : 		extra -= 257;
; 105  : 		end = 256;

	mov	DWORD PTR _end$[ebp], 256		; 00000100H
	mov	DWORD PTR _base$[ebp], eax
	mov	eax, OFFSET FLAT:_lext
	sub	eax, ecx
	mov	DWORD PTR _extra$[ebp], eax

; 106  : 	}
; 107  : 	else // DISTS

	jmp	SHORT $L60122
$L60121:

; 108  : 	{
; 109  : 		base = dbase;
; 110  : 		extra = dext;
; 111  : 		end = -1;

	or	DWORD PTR _end$[ebp], -1
	mov	DWORD PTR _base$[ebp], OFFSET FLAT:_dbase
	mov	DWORD PTR _extra$[ebp], OFFSET FLAT:_dext
$L60122:

; 112  : 	}
; 113  : 
; 114  : 
; 115  :     /*
; 116  :        Process a set of code lengths to create a canonical Huffman code.  The
; 117  :        code lengths are lens[0..codes-1].  Each length corresponds to the
; 118  :        symbols 0..codes-1.  The Huffman code is generated by first sorting the
; 119  :        symbols by length from short to long, and retaining the symbol order
; 120  :        for codes with equal lengths.  Then the code starts with all zero bits
; 121  :        for the first code of the shortest length, and the codes are integer
; 122  :        increments for the same length, and zeros are appended as the length
; 123  :        increases.  For the deflate format, these bits are stored backwards
; 124  :        from their more natural integer increment ordering, and so when the
; 125  :        decoding tables are built in the large loop below, the integer codes
; 126  :        are incremented backwards.
; 127  : 
; 128  :        This routine assumes, but does not check, that all of the entries in
; 129  :        lens[] are in the range 0..MAXBITS.  The caller must assure c.
; 130  :        1..MAXBITS is interpreted as that code length.  zero means that that
; 131  :        symbol does not occur in c code.
; 132  : 
; 133  :        The codes are sorted by computing a count of codes for each length,
; 134  :        creating from that a table of starting indices for each length in the
; 135  :        sorted table, and then entering the symbols in order in the sorted
; 136  :        table.  The sorted table is pWork[], with that space being provided by
; 137  :        the caller.
; 138  : 
; 139  :        The length counts are used for other purposes as well, i.e. finding
; 140  :        the minimum and maximum length codes, determining if there are any
; 141  :        codes at all, checking for a valid set of lengths, and looking ahead
; 142  :        at length counts to determine sub-table sizes when building the
; 143  :        decoding tables.
; 144  :      */
; 145  : 
; 146  : 	// accumulate lengths for codes (assumes lens[] all in 0..MAXBITS)
; 147  : 	assert(codes > 0);
; 148  : 	sym = 0;

	mov	ecx, DWORD PTR _lens$[ebp]
	xor	esi, esi
$L60124:

; 149  : 	do
; 150  : 	{
; 151  : 		++pTempVar->count[lens[sym]];

	mov	eax, DWORD PTR [ecx]
	add	DWORD PTR [edx+eax*4+1152], 1

; 152  : 		++sym;

	add	esi, 1
	add	ecx, 4

; 153  : 	} while(sym < codes);

	cmp	esi, DWORD PTR _codes$[ebp]
	lea	eax, DWORD PTR [edx+eax*4+1152]
	jl	SHORT $L60124

; 154  : 
; 155  : 
; 156  : 	// bound code lengths, force root to be within code lengths
; 157  : 	nMax = MAXBITS;

	push	15					; 0000000fH

; 158  : 	do
; 159  : 	{
; 160  : 		if (pTempVar->count[nMax] != 0)

	lea	eax, DWORD PTR [edx+1212]
	pop	ecx
	mov	DWORD PTR _nMax$[ebp], ecx
$L60237:
	cmp	DWORD PTR [eax], ebx
	jne	SHORT $L60129

; 161  : 			break;
; 162  : 
; 163  : 		--nMax;

	sub	ecx, 1
	sub	eax, 4

; 164  : 	} while(nMax >= 1);

	cmp	ecx, edi
	mov	DWORD PTR _nMax$[ebp], ecx
	jge	SHORT $L60237
$L60129:

; 165  : 
; 166  : 	nMin = 1;
; 167  : 	do
; 168  : 	{
; 169  : 		if (pTempVar->count[nMin] != 0)

	mov	ebx, DWORD PTR [edx+1156]
	lea	eax, DWORD PTR [edx+1156]
	mov	esi, edi
	test	ebx, ebx
	mov	DWORD PTR _nMin$[ebp], esi
	jne	SHORT $L60133
$L60131:

; 170  : 			break;
; 171  : 
; 172  : 		++nMin;

	add	esi, 1
	add	eax, 4

; 173  : 	} while(nMin <= nMax);

	cmp	esi, ecx
	mov	DWORD PTR _nMin$[ebp], esi
	jg	SHORT $L60133

; 165  : 
; 166  : 	nMin = 1;
; 167  : 	do
; 168  : 	{
; 169  : 		if (pTempVar->count[nMin] != 0)

	cmp	DWORD PTR [eax], 0
	je	SHORT $L60131
$L60133:

; 174  : 	
; 175  : 	root = *bits;

	mov	eax, DWORD PTR _bits$[ebp]
	mov	eax, DWORD PTR [eax]

; 176  : 	if (root > nMax)

	cmp	eax, ecx
	mov	DWORD PTR _root$[ebp], eax
	jle	SHORT $L60135

; 177  : 		root = nMax;

	mov	DWORD PTR _root$[ebp], ecx
$L60135:

; 178  : 		
; 179  : 	if (root < nMin)

	cmp	DWORD PTR _root$[ebp], esi
	jge	SHORT $L60136

; 180  : 		root = nMin;

	mov	DWORD PTR _root$[ebp], esi
$L60136:

; 181  : 
; 182  : 	used = (1U << root);          /* use root table entries */

	mov	ecx, DWORD PTR _root$[ebp]
	mov	esi, edi
	shl	esi, cl

; 183  : 
; 184  : 	// check available table space
; 185  : 	if (type == LENS && used >= ENOUGH - MAXD)

	cmp	DWORD PTR _type$[ebp], edi
	mov	DWORD PTR _used$[ebp], esi
	jne	SHORT $L60137
	cmp	esi, 1286				; 00000506H
	jl	SHORT $L60137

; 186  : 		return 1;

	mov	eax, edi
	jmp	$L60095
$L60137:

; 191  : 	left = 1;
; 192  : 	do
; 193  : 	{
; 194  : 		left <<= 1;
; 195  : 		left -= pTempVar->count[len];

	push	2
	pop	eax
	sub	eax, ebx

; 196  : 		if (left < 0)

	js	SHORT $L60215

; 187  : 
; 188  : 
; 189  : 	// check for an over-subscribed or incomplete set of lengths
; 190  : 	len = 1;

	lea	ecx, DWORD PTR [edx+1156]
$L60138:

; 198  : 		++len;

	add	edi, 1
	add	ecx, 4

; 199  : 	} while(len <= MAXBITS && left > 0);

	cmp	edi, 15					; 0000000fH
	jg	SHORT $L60142
	test	eax, eax
	jle	SHORT $L60143
	add	eax, eax
	sub	eax, DWORD PTR [ecx]
	jns	SHORT $L60138

; 197  : 			return -1;        //over-subscribed

	jmp	SHORT $L60215
$L60142:

; 200  : 
; 201  : 	if (left > 0 && (type == CODES || (codes - pTempVar->count[0] != 1)))

	test	eax, eax
	jle	SHORT $L60143
	cmp	DWORD PTR _type$[ebp], 0
	je	SHORT $L60215
	mov	eax, DWORD PTR _codes$[ebp]
	sub	eax, DWORD PTR [edx+1152]
	cmp	eax, 1
	je	SHORT $L60143
$L60215:

; 202  : 		return -1;                      /* incomplete set */

	or	eax, -1
	jmp	$L60095
$L60143:

; 203  : 
; 204  : 	// generate offsets into symbol table for each length for sorting
; 205  : 	len = 1;

	push	14					; 0000000eH
	lea	eax, DWORD PTR [edx+1156]
	pop	ecx
$L60145:

; 206  : 	do
; 207  : 	{
; 208  : 		pTempVar->offs[len + 1] = (pTempVar->offs[len] + pTempVar->count[len]);

	mov	edi, DWORD PTR [eax+64]
	add	edi, DWORD PTR [eax]

; 209  : 		++len;

	add	eax, 4

; 210  : 	} while(len < MAXBITS);

	sub	ecx, 1
	mov	DWORD PTR [eax+64], edi
	jne	SHORT $L60145

; 211  : 
; 212  : 	// sort symbols by length, by symbol order within each length
; 213  : 	sym = 0;

	mov	edi, DWORD PTR _lens$[ebp]
	xor	ecx, ecx
$L60148:

; 214  : 	do
; 215  : 	{
; 216  : 		int x = lens[sym];

	mov	eax, DWORD PTR [edi]

; 217  : 		if (x != 0)

	test	eax, eax
	je	SHORT $L60152

; 218  : 		{
; 219  : 			pTempVar->work[pTempVar->offs[x]++] = sym;

	mov	ebx, DWORD PTR [edx+eax*4+1216]
	lea	eax, DWORD PTR [edx+eax*4+1216]
	mov	DWORD PTR [edx+ebx*4], ecx
	add	DWORD PTR [eax], 1
$L60152:

; 220  : 		}
; 221  : 		++sym;		 

	add	ecx, 1
	add	edi, 4

; 222  : 	} while(sym < codes);

	cmp	ecx, DWORD PTR _codes$[ebp]
	jl	SHORT $L60148

; 223  : 	 
; 224  :     /*
; 225  :        Create and fill in decoding tables.  In c loop, the table being
; 226  :        filled is at next and has curr index bits.  The code being used is huff
; 227  :        with length len.  That code is converted to an index by dropping drop
; 228  :        bits off of the bottom.  For codes where len is less than drop + curr,
; 229  :        those top drop + curr - len bits are incremented through all values to
; 230  :        fill the table with replicated entries.
; 231  : 
; 232  :        root is the number of index bits for the root table.  When len exceeds
; 233  :        root, sub-tables are created pointed to by the root entry with an index
; 234  :        of the low root bits of huff.  This is saved in low to check for when a
; 235  :        new sub-table should be started.  drop is zero when the root table is
; 236  :        being filled, and drop is root when sub-tables are being filled.
; 237  : 
; 238  :        When a new sub-table is needed, it is necessary to look ahead in the
; 239  :        code lengths to determine what size sub-table is needed.  The length
; 240  :        counts are used for c, and so count[] is decremented as codes are
; 241  :        entered in the tables.
; 242  : 
; 243  :        used keeps track of how many table entries have been allocated from the
; 244  :        provided *table space.  It is checked when a LENS table is being made
; 245  :        against the space in *table, ENOUGH, minus the maximum space needed by
; 246  :        the worst case distance code, MAXD.  This should never happen, but the
; 247  :        sufficiency of ENOUGH has not been proven exhaustively, hence the check.
; 248  :        This assumes that when type == LENS, bits == 9.
; 249  : 
; 250  :        sym increments through all symbols, and the loop terminates when
; 251  :        all codes of length nMax, i.e. all codes, have been processed.  This
; 252  :        routine permits incomplete codes, so another loop after c one fills
; 253  :        in the rest of the decoding tables with invalid code markers.
; 254  :      */
; 255  : 
; 256  : 	// initialize state for loop
; 257  : 	huff = 0;                   /* starting code */
; 258  : 	sym = 0;                    /* starting code symbol */
; 259  : 	len = nMin;                  /* starting code length */

	mov	eax, DWORD PTR _nMin$[ebp]

; 260  : 	next = *table;              /* current table to fill in */
; 261  : 	curr = root;                /* current table index bits */
; 262  : 	drop = 0;                   /* current bits to drop from code for index */
; 263  : 	low = (unsigned int)-1;   	/* trigger new sub-table when len > root */

	or	DWORD PTR _low$[ebp], -1
	mov	edi, DWORD PTR _root$[ebp]
	mov	DWORD PTR _len$[ebp], eax
	mov	eax, DWORD PTR _table$[ebp]
	xor	ecx, ecx

; 264  : 	mask = used - 1;            /* mask for comparing low */

	sub	esi, 1
	mov	DWORD PTR _huff$[ebp], ecx
	mov	eax, DWORD PTR [eax]
	mov	DWORD PTR _curr$[ebp], edi
	mov	DWORD PTR _drop$[ebp], ecx
	mov	DWORD PTR _mask$[ebp], esi

; 265  : 
; 266  : 	// process all codes and make table entries
; 267  : 	int nResult = 0;

	mov	DWORD PTR _nResult$[ebp], ecx
	mov	DWORD PTR -28+[ebp], edx
$L60156:

; 268  : 	for (;;)
; 269  : 	{
; 270  : 		// pre-calculate a variable for multiple checks
; 271  : 		v = (len - drop);
; 272  : 
; 273  : 		// create table entry
; 274  : 		unsigned char* p = (unsigned char*)&c;
; 275  : 		int idx = pTempVar->work[sym];

	mov	ecx, DWORD PTR -28+[ebp]
	mov	edx, DWORD PTR _len$[ebp]
	sub	edx, DWORD PTR _drop$[ebp]
	mov	ecx, DWORD PTR [ecx]

; 276  : 		if (idx < end)

	cmp	ecx, DWORD PTR _end$[ebp]
	jge	SHORT $L60238

; 277  : 		{
; 278  : 			*p++ = 0;

	and	BYTE PTR _c$[ebp], 0

; 279  : 			*p++ = (unsigned char)v;

	mov	BYTE PTR _c$[ebp+1], dl
$L60239:

; 280  : 			*((unsigned short*)p) = (unsigned short)idx;

	mov	WORD PTR _c$[ebp+2], cx

; 281  : 		}
; 282  : 		else if (idx > end)

	jmp	SHORT $L60171
$L60238:
	jle	SHORT $L60166

; 283  : 		{
; 284  : 			*p++ = (unsigned char)extra[idx];

	mov	esi, ecx
	mov	ecx, DWORD PTR _extra$[ebp]
	shl	esi, 2

; 285  : 			*p++ = (unsigned char)v;

	mov	BYTE PTR _c$[ebp+1], dl
	mov	cl, BYTE PTR [esi+ecx]
	mov	BYTE PTR _c$[ebp], cl

; 286  : 			*((unsigned short*)p) = (unsigned short)base[idx];

	mov	ecx, DWORD PTR _base$[ebp]
	mov	cx, WORD PTR [esi+ecx]

; 287  : 		}
; 288  : 		else

	jmp	SHORT $L60239
$L60166:

; 289  : 		{
; 290  : 			*p++ = 96;
; 291  : 			*p++ = (unsigned char)v;
; 292  : 			*((unsigned short*)p) = 0;

	and	WORD PTR _c$[ebp+2], 0
	mov	BYTE PTR _c$[ebp], 96			; 00000060H
	mov	BYTE PTR _c$[ebp+1], dl
$L60171:

; 293  : 		}
; 294  : 
; 295  : 		// replicate for those indices with low len bits equal to huff
; 296  : 		incr = (1U << v);
	mov	ebx, 1

; 297  : 		fill = (1U << curr);
; 298  : 
; 299  : 		int x = (huff >> drop);

	mov	edi, DWORD PTR _huff$[ebp]
	mov	ecx, edx
	mov	esi, ebx
	shl	esi, cl
	mov	ecx, DWORD PTR _curr$[ebp]
	shl	ebx, cl
	mov	ecx, DWORD PTR _drop$[ebp]
	shr	edi, cl
	mov	DWORD PTR -68+[ebp], ebx
	add	edi, ebx
	lea	ecx, DWORD PTR [eax+edi*4]
$L60175:

; 300  : 		do
; 301  : 		{
; 302  : 			fill -= incr;

	mov	edi, esi
	sub	ebx, esi
	shl	edi, 2
	sub	ecx, edi

; 303  : 			assert(fill >= 0);
; 304  : 			next[x + fill] = c;

	mov	edi, DWORD PTR _c$[ebp]

; 305  : 		} while (fill > 0);

	test	ebx, ebx
	mov	DWORD PTR [ecx], edi
	ja	SHORT $L60175

; 306  : 
; 307  : 		// backwards increment the len-bit code huff
; 308  : 		incr = (1U << (len - 1));

	mov	edi, DWORD PTR _len$[ebp]
	mov	esi, 1
	lea	ecx, DWORD PTR [edi-1]
	shl	esi, cl

; 309  : 		while (huff & incr)

	mov	ecx, DWORD PTR _huff$[ebp]
$L60240:
	test	esi, ecx
	je	SHORT $L60181

; 310  : 			incr >>= 1;

	shr	esi, 1

; 309  : 		while (huff & incr)

	jmp	SHORT $L60240
$L60181:

; 311  : 		  
; 312  : 		if (incr != 0)

	test	esi, esi
	je	SHORT $L60182

; 313  : 		{
; 314  : 			huff &= (incr - 1);

	lea	ebx, DWORD PTR [esi-1]
	and	ebx, ecx

; 315  : 			huff += incr;

	add	ebx, esi
	mov	DWORD PTR _huff$[ebp], ebx

; 316  : 		}
; 317  : 		else

	jmp	SHORT $L60183
$L60182:

; 318  : 			huff = 0;

	and	DWORD PTR _huff$[ebp], 0
$L60183:

; 319  : 
; 320  : 		// go to next symbol, update count, len
; 321  : 		sym++;
; 322  : 
; 323  : 		if (--(pTempVar->count[len]) == 0)

	mov	ecx, DWORD PTR _pTempVar$[ebp]
	add	DWORD PTR -28+[ebp], 4
	sub	DWORD PTR [ecx+edi*4+1152], 1
	lea	ecx, DWORD PTR [ecx+edi*4+1152]
	jne	SHORT $L60184

; 324  : 		{
; 325  : 			if (len == nMax)

	cmp	edi, DWORD PTR _nMax$[ebp]
	je	$L60227

; 326  : 				break;
; 327  : 			
; 328  : 			len = lens[pTempVar->work[sym]];

	mov	ecx, DWORD PTR -28+[ebp]
	mov	edx, DWORD PTR _lens$[ebp]
	mov	ecx, DWORD PTR [ecx]
	mov	edx, DWORD PTR [edx+ecx*4]
	mov	DWORD PTR _len$[ebp], edx

; 329  : 			v = (len - drop);

	sub	edx, DWORD PTR _drop$[ebp]
	mov	edi, DWORD PTR _len$[ebp]
$L60184:

; 330  : 		}
; 331  : 
; 332  : 		// create new sub-table if needed
; 333  : 		if (len > root && (int)(huff & mask) != low)

	cmp	edi, DWORD PTR _root$[ebp]
	jle	$L60156
	mov	edi, DWORD PTR _mask$[ebp]
	and	edi, DWORD PTR _huff$[ebp]
	cmp	edi, DWORD PTR _low$[ebp]
	mov	DWORD PTR -52+[ebp], edi
	je	$L60156

; 334  : 		{
; 335  : 			// if first time, transition to sub-tables
; 336  : 			if (drop == 0)

	cmp	DWORD PTR _drop$[ebp], 0

; 337  : 			{
; 338  : 				drop = root;

	mov	ebx, DWORD PTR _root$[ebp]
	jne	SHORT $L60188

; 339  : 				v = (len - drop);

	mov	edx, DWORD PTR _len$[ebp]
	mov	DWORD PTR _drop$[ebp], ebx
	sub	edx, ebx
$L60188:

; 340  : 			}
; 341  : 			
; 342  : 			// increment past last table
; 343  : 			next += (1U << curr);

	mov	ecx, DWORD PTR -68+[ebp]

; 344  : 
; 345  : 			// determine length of next table
; 346  : 			curr = v;
; 347  : 			left = (1U << curr);

	push	1
	pop	esi
	mov	DWORD PTR _curr$[ebp], edx
	lea	eax, DWORD PTR [eax+ecx*4]
	mov	ecx, edx
	shl	esi, cl

; 348  : 
; 349  : 			while ((curr + drop) < nMax)

	mov	ecx, DWORD PTR _drop$[ebp]
	add	edx, ecx
	cmp	edx, DWORD PTR _nMax$[ebp]
	jge	SHORT $L60216
	mov	ecx, DWORD PTR _pTempVar$[ebp]
	lea	ecx, DWORD PTR [ecx+edx*4+1152]
$L60190:

; 350  : 			{
; 351  : 				left -= pTempVar->count[(curr + drop)];

	sub	esi, DWORD PTR [ecx]

; 352  : 				if (left <= 0)

	test	esi, esi
	jle	SHORT $L60229

; 353  : 					break;
; 354  : 				
; 355  : 				++curr;

	add	DWORD PTR _curr$[ebp], 1
	add	ecx, 4
	add	edx, 1

; 356  : 				left <<= 1;

	shl	esi, 1
	cmp	edx, DWORD PTR _nMax$[ebp]
	jl	SHORT $L60190
$L60229:

; 348  : 
; 349  : 			while ((curr + drop) < nMax)

	mov	edi, DWORD PTR -52+[ebp]
$L60216:

; 357  : 			}
; 358  : 
; 359  : 			// check for enough space
; 360  : 			used += (1U << curr);

	mov	edx, DWORD PTR _curr$[ebp]
	push	1
	pop	esi
	mov	ecx, edx
	shl	esi, cl

; 361  : 			if (type == LENS && used >= ENOUGH - MAXD)

	push	1
	pop	ecx
	add	DWORD PTR _used$[ebp], esi
	cmp	DWORD PTR _type$[ebp], ecx
	jne	SHORT $L60193
	cmp	DWORD PTR _used$[ebp], 1286		; 00000506H
	jge	SHORT $L60218
$L60193:

; 364  : 				break;
; 365  : 			}
; 366  : 
; 367  : 			// point entry in root table to sub-table
; 368  : 			low = (huff & mask);
; 369  : 
; 370  : 			p = (unsigned char*)&(*table)[low];

	mov	esi, DWORD PTR _table$[ebp]
	mov	ecx, edi
	mov	DWORD PTR _low$[ebp], ecx
	mov	edi, DWORD PTR [esi]

; 371  : 			*p++ = (unsigned char)(curr);

	mov	BYTE PTR [edi+ecx*4], dl

; 372  : 			*p++ = (unsigned char)(root);
; 373  : 			*((unsigned short*)p) = (unsigned short)(next - *table);

	mov	edx, eax
	lea	ecx, DWORD PTR [edi+ecx*4]
	add	ecx, 1
	mov	BYTE PTR [ecx], bl
	sub	edx, DWORD PTR [esi]
	sar	edx, 2
	mov	WORD PTR [ecx+1], dx

; 374  : 		}
; 375  : 	}

	jmp	$L60156
$L60218:

; 362  : 			{
; 363  : 				++nResult;

	mov	DWORD PTR _nResult$[ebp], ecx
	jmp	SHORT $L60157
$L60227:
	mov	ebx, DWORD PTR _root$[ebp]
$L60157:

; 376  : 
; 377  : 	// set return parameters
; 378  : 	*table += used;

	mov	eax, DWORD PTR _used$[ebp]

; 379  : 	*bits = root;
; 380  : 
; 381  : 	DestroyMemory(pTempVar);

	mov	ecx, eax
	mov	eax, DWORD PTR _table$[ebp]
	shl	ecx, 2
	add	DWORD PTR [eax], ecx
	mov	eax, DWORD PTR _bits$[ebp]
	mov	DWORD PTR [eax], ebx

	invoke GetProcessHeap
	invoke HeapFree, eax, 0, DWORD PTR _pTempVar$[ebp] 

; 382  : 	return nResult;

	mov	eax, DWORD PTR _nResult$[ebp]
$L60095:
	pop	edi
	pop	esi
	pop	ebx

; 383  : }

	leave
	ret	20					; 00000014H
_inflate_table@20 ENDP ; inflate_table
_TEXT	ENDS

END
